// ConsoleView.cpp : implementation of the CConsoleView class
//

#include "stdafx.h"
#include "Console.h"

#include "ConsoleDoc.h"
#include "ConsoleView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConsoleView

IMPLEMENT_DYNCREATE(CConsoleView, CView)

BEGIN_MESSAGE_MAP(CConsoleView, CView)
	//{{AFX_MSG_MAP(CConsoleView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConsoleView construction/destruction

CConsoleView::CConsoleView() : text(0,1000), buf(&text)
{
	out=new ostream(&buf);
	parser=new CParser(out,"");
	valid=0;
	firstpaint=1;
}

CConsoleView::~CConsoleView()
{
	if(out)
		delete out;
	if(parser)
		delete parser;
}

BOOL CConsoleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CConsoleView drawing

void CConsoleView::OnDraw(CDC* pDC)
{
	CConsoleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(valid&&firstpaint)
	{
		firstpaint=0;
		CString title="test";

		if(!parser->SetFile(".\\standard\\test.c"))
		{
			CFileDialog dialog(1,".c",0,0,"C Files (*.c)|*.c||",this);
			dialog.DoModal();
			title=dialog.GetFileTitle();
			parser->SetFile(dialog.GetPathName());
		}

		*out << "TI-92 assembly:" << endl;
		*out << parser->To68kAsm();
		*out << "Saving" << endl << endl;
		fstream fout(title+".asm",ios::out,filebuf::openprot);
		fout << parser->To68kAsm();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CConsoleView printing

BOOL CConsoleView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CConsoleView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CConsoleView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CConsoleView diagnostics

#ifdef _DEBUG
void CConsoleView::AssertValid() const
{
	CView::AssertValid();
}

void CConsoleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CConsoleDoc* CConsoleView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CConsoleDoc)));
	return (CConsoleDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CConsoleView message handlers

int CConsoleView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!text.Create(CRect(0,0,lpCreateStruct->cx,lpCreateStruct->cy-17),this,(UINT)1000))
	{
		TRACE0("Failed to create view\n");
		return -1;      // fail to create
	}
	/*if (!line.Create(CRect(0,0,0,0),this,&pDoc->decoder,(UINT)1001))
	{
		TRACE0("Failed to create input line\n");
		return -1;      // fail to create
	}*/
	
	return 0;
}

void CConsoleView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	if(cx==0||cy==0)
		return;
	text.SetWindowPos(0,0,0,cx,cy,SWP_NOMOVE|SWP_NOOWNERZORDER);

	/*if(!line.SetWindowPos(0,2,cy-23,cx-2,20,SWP_NOOWNERZORDER))
	{
		gout << "Error! I couldn't move the inputline." << endl;
	}*/
	if(!valid)
	{
		valid=1;
	}
}
