// ColoredTextView.cpp : implementation file
//

#include "stdafx.h"
#include "ColoredText.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DELETELINENUM	20
#define TABSIZE			40

CLine::CLine()
{
	linewrap=0;
}

CLine::~CLine()
{
}

CColor CLine::AddText(CString text,CColor oldcolor)
{
	if(text.GetLength()<1)
	{
		cout << "Error!" << endl;
		return oldcolor;
	}
	if(text.Find("\x1b[")==-1&&text[0]!='\t')
	{
		AppendOldText(text);
		return FindColor(colors[texts.GetSize()-1],texts.GetSize()-1);
	}
	
	int num=texts.Add(text);
	RemoveReturns(num);
	CColor color;
	colors.Add(color);
	RemoveReturns(num);
	FindColor(oldcolor,num);
	if(num>0)
	{
		if(colors[num]==colors[num-1]&&text[0]!='\t')
		{
			AppendOldText(texts[num],num-1);
			texts.RemoveAt(num);
			num--;
			FindColor(colors[num],num);
		}
	}

	return colors[num];
}

CColor CLine::AppendOldText(CString text,int num)
{
	if(num==-1)
		num=texts.GetSize()-1;
	if(num<0)
	{
		num=texts.Add(text);
		colors.Add(*new CColor());
	}
	else
	{
		texts[num]+=text;
	}
	RemoveReturns(num);
	return colors[num];
}

CString CLine::GetText()
{
	if(IsEmpty())
		return "";
	CString ret=texts[0];
	for(int i=1; i<texts.GetSize(); i++)
	{
		ret+=texts[i];
	}
	return ret;
}

CString CLine::GetText(int ending)
{
	if(ending>texts.GetSize())
		ending=texts.GetSize();
	CString ret=texts[0];
	for(int i=1; i<ending; i++)
	{
		ret+=texts[i];
	}
	return ret;
}

void CLine::ResetTexts()
{
	texts.RemoveAll();
	colors.RemoveAll();
}

CColor CLine::FindColor(CColor oldcolor,int num)
{
	if(colors.GetSize()<=num)
	{
		CColor temp;
		colors.Add(temp);
	}
	int startpos=texts[num].Find("\x1b[");
	if(startpos==-1)
	{
		colors[num]=oldcolor;
		return colors[num];
	}
	CColor newcolor=oldcolor;

	int position=startpos+2;
	int endpos=0;
	int code=0;
	while(1)
	{
		if(texts[num].Mid(position+1,1)==";"||
			texts[num].Mid(position+1,1)=="m")
		{
			endpos=position+1;
		}
		else if(texts[num].Mid(position+2,1)==";"||
			texts[num].Mid(position+2,1)=="m")
		{
			endpos=position+2;
		}
		else
		{
			return oldcolor;
		}
		if(sscanf(texts[num].Mid(position,endpos-position),"%d",&code)==0)
		{
			return oldcolor;
		}
		if(!newcolor.InterpretColor(code))
			return oldcolor;
		if(texts[num].Mid(endpos,1)=='m')
		{
			texts[num]=texts[num].Mid(0,startpos)+texts[num].Mid(endpos+1);
			colors[num]=newcolor;
			return colors[num];
		}
		else
			position=endpos+1;
	}
	return oldcolor;
}

void CLine::RemoveReturns(int num)
{
	int size=texts[num].GetLength();
	if(size<1)
		return;
	if(texts[num][size-1]=='\r'||texts[num][size-1]=='\n')
	{
		if(size>1)
			texts[num]=texts[num].Mid(0,size-1);
		else
			texts[num]="";
	}
	size=texts[num].GetLength();
	if(size<1)
		return;
	if(texts[num][size-1]=='\r'||texts[num][size-1]=='\n')
	{
		if(size>1)
			texts[num]=texts[num].Mid(0,size-1);
		else
			texts[num]="";
	}
}

CLine& CLine::operator = (CLine &source)
{
	texts.RemoveAll();
	colors.RemoveAll();
	texts.SetSize(source.texts.GetSize());
	colors.SetSize(source.colors.GetSize());
	for(int i=0; i<source.texts.GetSize(); i++)
	{
		texts.Add(source.texts[i]);
		colors.Add(source.colors[i]);
	}
	linewrap=source.linewrap;
	return *this;
}

/////////////////////////////////////////////////////////////////////////////
// CColoredText

IMPLEMENT_DYNCREATE(CColoredText, CWnd)

BEGIN_MESSAGE_MAP(CColoredText, CWnd)
//{{AFX_MSG_MAP(CColoredText)
	ON_WM_CREATE()
	ON_WM_VSCROLL()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CColoredText::CColoredText()
{
	lines.AddTail(*new CLine());
}

CColoredText::CColoredText(COReceiver* o,int mlinenum)
{
	//iPtSize=11;
	//pszFace= "Courier New";
	maxlinenum=mlinenum;
	rec=o;
	checkwidth=0;
	lines.AddTail(*new CLine());
}


void CColoredText::SetCharWidths()
{
	CClientDC dc(this);
	tf.CreateFont(-12, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "Courier New");
	dc.SelectObject(tf);
	dc.GetCharWidth(0,255,cwidths);
	LOGFONT logf;
	tf.GetLogFont(&logf);
	cheight=(long)(-1.3*(double)logf.lfHeight);
}

void CColoredText::Append(CString text,int sendtorec)
{
	int totalsize;
	if(checkwidth)
		totalsize=0;
	else
		totalsize=-1;
	BOOL newline=0;
	if(!lines.IsEmpty()&&!lines.GetTail().IsEmpty())
	{
		totalsize=FindStringWidth(lines.GetTail().GetText());
	}
	//int textlen=strlen(text);
	int i;
	while(text!="")
	{
		i=0;
		while(text.GetLength()>i&&totalsize<checkwidth&&text[i]!='\n'&&((text[i]!='\x1b'&&text[i]!='\t')||i==0))
		{
			if(text[i]=='\r')
			{
				i++;
				continue;
			}
			else
			{
				if(checkwidth)
					totalsize+=cwidths[(unsigned char)text[i]];
			}
			int textlen=text.GetLength();
			i++;
		}
		CString temp=text.Mid(0,i);
		newline=0;
		if(totalsize>=checkwidth||(text.GetLength()>i&&text[i]=='\n'))
		{
			newline=1;
		}
		if(text.GetLength()>i&&text[i]=='\n')
			lines.GetTail().linewrap=0;
		else if(totalsize>=checkwidth)
			lines.GetTail().linewrap=1;
		currentcolor=lines.GetTail().AddText(temp,currentcolor);
		if(newline)
		{
			if(lines.GetTail().linewrap)

				text=text.Mid(i);
			else
			{
				if(text.GetLength()>i+1&&text[i+1]=='\r')
					text=text.Mid(i+2);
				else
					text=text.Mid(i+1);
			}
			lines.AddTail(*(new CLine()));
			CheckTooManyLines();
			if(checkwidth)
				totalsize=0;
		}
		else
		{
			text=text.Mid(i);
		}
	}
	POSITION startpos=lines.GetTailPosition();
	if(sendtorec)
	{
		CString temp="";
		CLine *item=0;
		while(startpos)
		{
			temp+=lines.GetAt(startpos).GetText();
			if(!lines.GetAt(startpos).linewrap&&rec)
			{
				rec->RecOutput(temp,this);
				temp="";
			}
			item=&lines.GetNext(startpos);
		}
		if(rec&&item->GetText()!="")
		{
			rec->RecPartLine(item->GetText(),this);
		}
	}
	//if(!IsIconic())
	dirtypos=1;

	if(::IsWindow(m_hWnd))
		Invalidate();
}

int CColoredText::FindStringWidth(CString adding)
{
	int total=0;
	for(int i=0; i<adding.GetLength(); i++)
	{
		total+=cwidths[(unsigned char)adding[i]];
	}
	return total;
}

/*void CColoredText::Save(ofstream *out)
{
	out->write((unsigned char*)&currentcolor,sizeof(currentcolor));
	out->write((unsigned char*)&currentline,sizeof(currentline));
	out->write((unsigned char*)&maxlinenum,sizeof(maxlinenum));
	for(int i=0; i<currentline; i++)
	{
		lines[i].Save(out);
	}
}*/


void CColoredText::CheckTooManyLines()
{
	if(lines.GetCount()>=maxlinenum)
	{
		lines.RemoveHead();
	}
}


/////////////////////////////////////////////////////////////////////////////
// CColoredText drawing

void CColoredText::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	scroller.SetScrollRange(0,lines.GetCount());
	if(dirtypos)
	{
		if(lines.GetCount()<checkheight/cheight)
			scroller.SetScrollPos(0);
		else
		{
			int enabled=scroller.EnableScrollBar();
			scroller.SetScrollPos(lines.GetCount()-checkheight/cheight);
		}
		dirtypos=0;
	}
	dc.SetBkColor(0x00000000);
	
	dc.SelectObject(tf);
	
	int d=0;
	int line=scroller.GetScrollPos();
	int x;
	POSITION pos=lines.FindIndex(line);
	CColor lastcolor;
	dc.SetTextColor(lastcolor);
	while(pos!=NULL)
	{
		x=0;
		for(d=0; d<lines.GetAt(pos).texts.GetSize(); d++)
		{
			if(lines.GetAt(pos).colors[d]!=lastcolor)
			{
				lastcolor=lines.GetAt(pos).colors[d];
				dc.SetTextColor(lastcolor);
			}
			if(d>=1)
			{
				//Placing the x here makes it so it doesn't have to be
				//calculated if there is only one text
				x+=FindStringWidth(lines.GetAt(pos).texts[d-1]);
			}
			CString text=lines.GetAt(pos).texts[d];
			if(lines.GetAt(pos).texts[d][0]=='\t')
			{
				x+=TABSIZE-x%TABSIZE;
				dc.TextOut(x,(line-scroller.GetScrollPos())*cheight,lines.GetAt(pos).texts[d].Mid(1));
			}
			else
			{
				dc.TextOut(x,(line-scroller.GetScrollPos())*cheight,lines.GetAt(pos).texts[d]);
			}
		}
		line++;
		lines.GetNext(pos);
	}
	
	// Do not call CView::OnPaint() for painting messages
}

/////////////////////////////////////////////////////////////////////////////
// CColoredText diagnostics

#ifdef _DEBUG
void CColoredText::AssertValid() const
{
	CWnd::AssertValid();
}

void CColoredText::Dump(CDumpContext& dc) const
{
	CWnd::Dump(dc);
}

#endif //_DEBUG

int CColoredText::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!scroller.Create(WS_VISIBLE|SBS_VERT|SBS_LEFTALIGN,CRect(0,0,0,0),this,-1))
	{
		TRACE0("Failed to create scroller\n");
		return -1;      // fail to create
	}

	SetCharWidths();

	scroller.SetScrollRange(0,0);
	scroller.SetScrollPos(0);
	
	return 0;
}

void CColoredText::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	switch(nSBCode)
	{
	case SB_BOTTOM:
		scroller.SetScrollPos(lines.GetCount()-checkheight/cheight);
	break;
	case SB_LINEDOWN:
		scroller.SetScrollPos(scroller.GetScrollPos()+cheight);
	break;
	case SB_LINEUP:
		scroller.SetScrollPos(scroller.GetScrollPos()-cheight);
	break;
	case SB_PAGEDOWN:
	break;
	case SB_PAGEUP:
	break;
	case SB_THUMBPOSITION:
		scroller.SetScrollPos(nPos);
	break;
	case SB_THUMBTRACK:
		scroller.SetScrollPos(nPos);
	break;
	case SB_TOP:
		scroller.SetScrollPos(0);
	break;
	}
	Invalidate();
	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CColoredText::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	if(cx==0||cy==0)
		return;
	scroller.SetWindowPos(0,cx-13,0,13,cy,SWP_NOOWNERZORDER);
	checkwidth=cx-12;
	checkheight=cy;
}

//Do something with references or pointers later
CLine::CLine(CLine & copy)
{
	*this=copy;
}

CColoredText::~CColoredText()
{
}

BOOL CLine::IsEmpty()
{
	if(texts.GetSize()==0)
		return 1;
	return 0;
}

BOOL CColoredText::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your messageh andler code here and/or call default
	CRect box;
	GetClientRect(&box);
	pDC->FillSolidRect(box,0x000000);
	return CWnd::OnEraseBkgnd(pDC);
}

BOOL CColoredText::Create(CRect & rect, CWnd * pParentWnd, UINT nID)
{
	return CWnd::Create(AfxRegisterWndClass(0),"text",WS_VISIBLE|WS_CHILD,rect,pParentWnd,nID,NULL);
}

COReceiver* CColoredText::SetReceiver(COReceiver *pRec)
{
	rec=pRec;
	return rec;
}

void CColor::Reset()
{
	attributes=0;
	color=07;
}

int CColor::SetForeground(int pForeground)
{
	color=(color/10)*10+pForeground;
	return color;
}

int CColor::SetBackground(int pBackground)
{
	color=color%10+pBackground;
	return color;
}

BOOL CColor::InterpretColor(char pCode)
{
	if(pCode/10==3)
	{
		SetForeground(pCode%10);
		return 1;
	}
	if(pCode/10==4)
	{
		SetBackground(pCode%10);
		return 1;
	}
	switch(pCode)
	{
	case 0:
		Reset();
		return 1;
	case 1:
		attributes|=BOLD;
		return 1;
	case 4:
		attributes|=UNDERSCORE;
		return 1;
	case 5:
		attributes|=BLINK;
		return 1;
	case 7:
		attributes|=REVERSE;
		return 1;
	case 22:
		attributes&=~BOLD;
		return 1;
	case 24:
		attributes&=~UNDERSCORE;
		return 1;
	case 25:
		attributes&=~BLINK;
		return 1;
	case 26:
		attributes&=~REVERSE;
		return 1;
	}
	return 0;
}

CColor::operator COLORREF()
{
//Colors:
//Foreground                      Background
//30 black                         40 black
//31 red                           41 red
//32 green                         42 green
//33 yellow                        43 yellow
//34 blue                          44 blue
//35 magenta                       45 magenta
//36 cyan                          46 cyan
//37 white                         47 white
	COLORREF ret;
	switch(GetForeground())
	{
	case 0:
		ret=0x000000;
		break;
	case 1:
		ret=0x0000FF;
		break; // red
	case 2:
		ret=0x00FF00;
		break; // green
	case 3:
		ret=0x00FFFF;
		break; // yellow
	case 4:
		ret=0xFF0000;
		break; //blue
	case 5:
		ret=0xFF00FF;
		break; //magenta
	case 6:
		ret=0xFFFF00;
		break; //cyan
	case 7:
		ret=0xFFFFFF;
		break;
	}
	if((attributes/BOLD)%2==1)
	{
		ret/=2;
	}
	return ret;
}

CColor::CColor()
{
	Reset();
}

char CColor::GetForeground()
{
	return color%10;
}
