// AsmCommand.cpp: implementation of the CAsmCommand class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AsmCommand.h"
#include "Variable.h"
#include "VariableManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CAsmCommand::~CAsmCommand()
{

}

CAsmCommand::CAsmCommand(CBlock * newparent, CProgram * newprog, CString newasm) : CCommand(newparent,newprog)
{
	toformat=newasm;
	type="CAsmCommand";
}

CString CAsmCommand::AddAsm(CString moreasm)
{
	toformat+=moreasm;
	return toformat;
}

void CAsmCommand::PreTo68kAsm()
{
	if(asmcode!="")
	{
		vmanager->SetOwnedRegs(usedregisters,this);
		return;
	}
	CString tempformat=toformat;
	int i=0;
	while(i=-1)
	{
		i=tempformat.Find('\n');
		if(i==-1)
			i=tempformat.Find('\r');
		if(i==-1)
			break;
		asmcode+=FormatLine(tempformat.Mid(0,i));
		tempformat=tempformat.Mid(i+1);
	}
	tempformat.TrimRight();
	if(tempformat!="")
		asmcode+=FormatLine(asmcode)+"\n";
}

CString CAsmCommand::FormatLine(CString line)
{
	line.TrimLeft();
	line.TrimRight();
	//find is for the comment here
	int find=line.Find(";");
	CString comment="";
	if(find!=-1)
	{
		comment=line.Mid(find);
		line=line.Mid(0,find);
		line.TrimRight();
	}
	//find is for the operands here
	find=line.Find(" ");
	if(find==-1||(line.Find('\t')!=-1&&find>line.Find('\t')))
	{
		find=line.Find('\t');
	}
	CString operands="";
	if(find!=-1)
	{
		operands=line.Mid(find+1);
		line=line.Mid(0,find);
		line.TrimRight();
	}
	//find is for the second operand here
	CString operand2="";
	find=operands.Find(",");
	if(find!=-1)
	{
		operand2=operands.Mid(find+1);
		operands=operands.Mid(0,find);
		return A68kOpcode(line,GetVariable(parent,prog,operands,1),
			GetVariable(parent,prog,operand2,1))+" "+comment+"\n";
	}
	
	return A68kOpcode(line,GetVariable(parent,prog,operands,1),0)+
		" "+comment+"\n";
}
