#include "stdafx.h"
#include "program.h"
#include "VariableManager.h"
#include "Langobjs.h"
#include "labelcommand.h"

CProgram::CProgram() :
	CBlock(0,this)
{
	functionnum=0;
	labelnum=0;
	vmanager=new CVariableManager();
}

CProgram::~CProgram()
{
	for(int i=0; i<functionnum; i++)
	{
		delete functions[i];
	}
	if(functionnum)
		delete[] functions;
}

int CProgram::AddItem(CFunction *newfunction)
{
	if(functionnum%5==0)
	{
		CFunction **temp=new CFunction*[functionnum+5];
		for(int i=0; i<functionnum; i++)
		{
			temp[i]=functions[i];
		}
		if(functionnum)
			delete[] functions;
		functions=temp;
	}
	functions[functionnum]=newfunction;
	return functionnum++;
}

CFunction *CProgram::FindItem(CString name)
{
	for(int i=0; i<functionnum; i++)
	{
		if(functions[i]->GetName()==name)
		{
			return functions[i];
		}
	}
	return 0;
}

CString CProgram::To68kAsm()
{
	CString ret;
	ret+=";Compiled with Sage version ";
	ret+=version;
	ret+=".\n";
	ret+="\tinclude	\"tios.h\"\n";
	ret+="\txdef	_main\n";
	ret+="\txdef	_comment\n\n";
	ret+=";*****************************************************\n\n";
	for(int i=0; i<functionnum; i++)
	{
		ret+=functions[i]->To68kAsm();
	}

	ret+=";*****************************************************\n\n";
	ret+="_comment	dc.b	\"Undefined\",0\n\n";
	ret+=";*****************************************************\n\n";
	for(i=0; i<variablenum; i++)
	{
		if(variables[i]->initialvalue)
		{
			ret+=variables[i]->GetName()+"\tdc"+
				variables[i]->GetLengthIdentifier()+"\t"+
				variables[i]->initialvalue->GetName()+"\n";
		}
		else
		{
			ret+=variables[i]->GetName()+"\t\tdc"+
				variables[i]->GetLengthIdentifier()+"\t0\n";
		}
	}
	ret+="\n;*****************************************************\n\n";
	ret+="\tend\n\n";

	return ret;
}

int CProgram::AddItem(CLabelCommand * newlabel)
{
	if(labelnum%5==0)
	{
		CLabelCommand **temp=new CLabelCommand*[labelnum+5];
		for(int i=0; i<labelnum; i++)
		{
			temp[i]=labels[i];
		}
		if(labelnum)
			delete[] labels;
		labels=temp;
	}
	labels[labelnum]=newlabel;
	return labelnum++;
}

CLabelCommand * CProgram::FindLabel(CString name)
{
	for(int i=0; i<labelnum; i++)
	{
		if(labels[i]->name==name)
		{
			return labels[i];
		}
	}
	return 0;
}

int CProgram::AddItem(CVariable * toadd)
{
	toadd->globalvar=1;
	return CBlock::AddItem(toadd);
}
