#ifndef VARIABLE_H
#define VARIABLE_H

#define	vmanager			mainmanager

#define	varNone			0
#define	varVoid			1
#define	varBool			varChar
#define	varChar			2
#define	varInt			3
#define	varLong			4
#define	varPointer		5

class CVariable;
#ifndef COMMAND_H
#include "command.h"
#endif
/*#ifndef VARIABLM_H
#include "variablm.h"
#endif*/

CVariable *GetVariable(CBlock *curblock,CProgram *prog,CString var="",
	BOOL inasm=0);

CString A68kOpcode(CString opcode,CVariable *source,CVariable *dest,
				   CString comments="");


class CVariable
{
	public:
		BOOL globalvar;
		void ReNeeded();
		int SetStackLevel(int newlevel);
		int oldstacklevel;
		BOOL usememory;
		BOOL IsPointer();
		BOOL direct;
	CString name;
	int type;
	int elements;
	int stacklevel;
	CCommand *parent;
	CString registeraccess;
	CString oldregisteraccess;
	CVariable *initialvalue;
	/*Contains the number of times the variable is used. This will be to
	determine how important the variable is, and where it should be loaded.*/
	int accesses;
	char needed;
	char constant;
	CVariable(CCommand *newparent,int newtype,CString newname,int newelements,
		CVariable *newinitialvalue);
	CVariable(CCommand *newparent,int value);
	CVariable(CCommand *newparent,CString value,BOOL inasm=0);
	void Used()
	{
		accesses++;
	}
	CString DoneWith(BOOL cleanstack=1);
	void Dirty()
	{
		registeraccess="";
	}
	int GetSize();
	CString GetLengthIdentifier();
	CString GetRegisterAccess()
	{
		if(constant)
			return GetName();
		return registeraccess;
	}
	CString GetLastRegisterAccess()
	{
		if(registeraccess!="")
			return registeraccess;
		return oldregisteraccess;
	}
	CString GetMemoryAccess();
	CString GetName()
	{
		return name;
	}
	CString Load(char dest=0,int place=-1);
	CString GetAccess()
	{
		if(constant)
			return GetName();
		if(registeraccess!=""&&!usememory)
			return registeraccess;
		return GetMemoryAccess();
	}
	char LoadedInRegister()
	{
		return (registeraccess!="");
	}
	char IsParent(CCommand *c);
	void SetRegister(CString str);
	int GetType()
	{
		if(elements||name=="&")
			return varPointer;
		return type;
	}
	char IsSigned()
	{
		return (type >> 4)%1; //Return the fifth bit of type.
	}
	CString GetCName()
	{
		if(constant&&name[0]=='#')
			return name.Mid(1);
		if(name=="*")
			return "*"+initialvalue->GetCName();
		return name;
	}
	char IsConstant()
	{
		return constant;
	}
};
#endif