#if !defined(PARSER_H)
#define PARSER_H
#include "stdafx.h"
class CParser;

class CScanner;
class CProgram;
class CBlock;
class CVariable;
class CFunction;

class CParser
{
	public:
		char CheckGoto(CString str1,CString st2);
		char CheckLabel(CString str1,CString str2);
		char CheckAsmcode(CString todecode);
		char CheckFunctionCall(CString funcname,CString paren);
		CString To68kAsm();
		int SetFile(CString fname);
	CScanner *scanner;
	CProgram *prog;
	CFunction *curfunc;
	CBlock *curblock;
	CParser(ostream *pOut,CString fname);

	void StartParsing();
	void ParseBlock(CBlock *ncurblock);

	char CheckPreprocessorDirective(CString str);
	char CheckInclude(CString str);
	char CheckIfStatement(CString str);

	char CheckFunction(int vartype,CString str1,CString str2);

	char CheckVariable(int vartype,CString str1,CString str2);
	char CheckAssignment(CVariable *var,CString str1);
	char CheckAddto(CVariable *var,CString str1);

	int GetBiggerType(CVariable *var1,CVariable *var2);
	int GetVariableType(CString str);
	CVariable *GetVariable(CString str);

	CVariable *DecodeExpression(CString end,CVariable *op1=0,CString newop="",CString end2="");
};
#endif
